--
-- PlayerStateActivateWorkshop
--
-- @author Rockstar
-- @date 26/05/2021
--


PlayerStateActivateWorkshop = {}
local PlayerStateActivateWorkshop_mt = Class(PlayerStateActivateWorkshop, PlayerStateBase)

local function NO_CALLBACK()
end

function PlayerStateActivateWorkshop:new(player, stateMachine)
	local self = PlayerStateBase:new(player, stateMachine, PlayerStateActivateWorkshop_mt)

	self.foundVehicle = nil
	self.interactText = ""
	self.castDistance = 3
	self.ownWorkshop = false

	-- workshopTabber fix
	self.showNextVehicle = NO_CALLBACK

	return self
end

function PlayerStateActivateWorkshop:isAvailable()
	local x, y, z = localToWorld(self.player.cameraNode, 0, 0, 1)
	local dx, dy, dz = localDirectionToWorld(self.player.cameraNode, 0, 0, -1)
	local collisionMask = 81797120

	self.foundVehicle = nil

	if self.player.isClient and self.player.isEntered and not g_gui:getIsGuiVisible() then
		raycastAll(x, y, z, dx, dy, dz, "vehicleRaycastCallback", self.castDistance, self, collisionMask)

		if self.foundVehicle ~= nil then
			self.interactText = string.format("%s: %s", g_i18n:getText("action_configSellSpecificVehicle"), self.foundVehicle:getFullName())

			return true
		end
	end

	self.interactText = ""

	return false
end

function PlayerStateActivateWorkshop:activate()
	PlayerStateActivateWorkshop:superClass().activate(self)

	local vehicle = self.foundVehicle

	-- seasons fix
	if g_seasons ~= nil then
		vehicle = {vehicle}
	end

	g_gui:showDirectSellDialog({
		vehicle = vehicle,
		owner = nil,
		ownWorkshop = self.ownWorkshop
	})

	self:deactivate()
end

function PlayerStateActivateWorkshop:vehicleRaycastCallback(hitActorId, x, y, z, distance, nx, ny, nz, subShapeIndex, hitShapeId)
	local object = g_currentMission:getNodeObject(hitActorId)

	if object ~= nil and object.isa ~= nil and object:isa(Vehicle) and g_currentMission.accessHandler:canFarmAccess(self.player.farmId, object) then
		self.foundVehicle = object

		return false
	end

	return true
end